<script>
    import InputComponent from './ui/InputComponent.vue'
    
    export default {
        components: { InputComponent },
        data: () => ({
            formData: {
                email: '',
                password: '',
            }
        }),
        methods: {
            validateInput(key, ref){
                if (this.formData[key] === null || this.formData[key] === '' ) {
                    this.$refs[ref].showError = true;
                    return true;
                } else return false
            }, 
            validateRegexp(key, ref){
                var regExpEmail = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,4})+$/.test(this.formData[key]);

                if (!regExpEmail) {
                    this.$refs[ref].regexpError = true;
                    return true;
                } else return false
            }, 
            validateForm(){
                var error = false;

                if (this.validateInput('email', 'loginEmail')) error = true;
                if (this.validateRegexp('email', 'loginEmail')) error = true;
                if (this.validateInput('password', 'loginPassword')) error = true;

                return error;
            },
            submitForm(){
                if (this.validateForm()) return;

                window.location.href = '/panel/chats'
                console.log('panel');
            }
        }
    }
</script>
<template>
    <div>

        <!-- EMAIL -->
        <div class="form-group">
            <label class="form-label" for="">Correo electrónico</label>
            <input-component
                v-model="formData.email"
                ref="loginEmail"
                errorMessage="Este campo es obligatorio."
                type="text"
                :regexp="/^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/g"
                regexErrorText="Formato invalido"
                :maxlength="255"
                @enter="submitForm()"
            />
        </div>

        <!-- PASSWORD -->
        <div class="form-group">
            <label class="form-label" for="">Contraseña</label>
            <input-component
                v-model="formData.password"
                ref="loginPassword"
                errorMessage="Este campo es obligatorio."
                type="password"
                :maxlength="255"
                @enter="submitForm()"
            />
        </div>

        <a class="tx-12 w-fit block ml-auto mb-8" href="#test-only">
            ¿Olvidaste tu contraseña?
        </a>

        <!-- BTN SUBMIT -->
        <button class="btn btn--blue-1 tx-medium flex mx-auto mb-3" @click="submitForm()">
            Entrar
        </button>

        <a class="tx-12 w-fit block mx-auto" href="#test-only">
            Obtener ayuda
        </a>
    </div>
</template>